{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Helper macros for FreeBSD ifconfig commands
 ####################################################################-#}
{#======================================================================
 # Get keywords
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig keywords for the supplied
 # interface, and echoes the list as a JSON string. ifconfig keywords
 # are built in the scope of a whole interface.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro get_keywords(interface, indexes) -%}
  {%- set keywords = [] -%}

  {%- if interface['auto_start']['on_boot'] is sameas false -%}
    {{ keywords.append("NOAUTO") }}
  {%- endif -%}
  {%- if interface['inet4']['dhcp']['enabled'] is sameas true -%}
    {{ keywords.append("DHCP") }}
  {%- endif -%}

  {{ keywords | to_json }}
{%- endmacro -%}

{#======================================================================
 # Get inet options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the IPv4
 # protocol, then echoes this list as a JSON string.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro get_inet_options(interface, indexes) -%}
  {%- set options = [] -%}

  {#- We only process inet options for enabled interfaces -#}
  {%- if interface['enabled'] is sameas true -%}

    {#- Set shortcut variables -#}
    {%- set inet4  = interface['inet4'] -%}
    {%- set arp    = interface['inet4']['arp'] -%}
    {%- set dhcp   = interface['inet4']['dhcp'] -%}
    {%- set static = interface['inet4']['static'] -%}

    {#- If IPv4 is explicitly disabled, disable ARP too -#}
    {%- if inet4['enabled'] is sameas false -%}
      {{ options.append("-arp") }}

    {#- Else, we consider IPv4 as being enabled -#}
    {%- else -%}

      {#- ARP explicit options -#}
      {%-   if arp['enabled'] is sameas true -%}
        {{ options.append("arp") }}
      {%- elif arp['enabled'] is sameas false -%}
        {{ options.append("-arp") }}
      {%- endif -%}

      {#- Main static IPv4 address. Only if DHCP is not enabled -#}
      {%- if static | length > 0 and not dhcp['enabled'] -%}
        {#- Get and normalize main IPv4 address for the interface -#}
        {%- set main_address_def = static[0] -%}
        {#- Format the main IPv4 address -#}
        {%- set main_address =
          helpers.format_inet_address(main_address_def) -%}
        {#- Store the main address -#}
        {%- if main_address -%}
          {{ options.append(main_address) }}
        {%- endif -%}
      {%- endif -%}
    {%- endif -%}
  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}

{#======================================================================
 # Get inet6 options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the IPv6
 # protocol, then echoes this list as a JSON string.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro get_inet6_options(interface, indexes) -%}
  {%- set options = [] -%}

  {#- We only process inet6 options for enabled interfaces -#}
  {%- if interface['enabled'] is sameas true -%}

    {#- Set shortcut variables -#}
    {%- set inet6  = interface['inet6'] -%}
    {%- set dad    = interface['inet6']['ndp']['dad'] -%}
    {%- set nud    = interface['inet6']['ndp']['nud'] -%}
    {%- set rtadv  = interface['inet6']['ndp']['rtadv'] -%}
    {%- set slaac  = interface['inet6']['slaac'] -%}
    {%- set ll     = interface['inet6']['slaac']['link_local'] -%}
    {%- set static = interface['inet6']['static'] -%}

    {#- If IPv6 is explicitly enabled -#}
    {%-   if inet6['enabled'] is sameas true -%}
      {{ options.append("-ifdisabled") }}
    {#- If IPv6 is explicitly disabled -#}
    {%- elif inet6['enabled'] is sameas false -%}
      {{ options.append("ifdisabled") }}
    {%- endif -%}

    {#- We consider IPv6 as being enabled unless explicitly disabled -#}
    {%- if inet6['enabled'] is not sameas false -%}

      {#----------------------------------------------------------------
       # NDP options
       #--------------------------------------------------------------#}
      {#- Duplicate Address Detection -#}
      {%-   if dad['enabled'] is sameas true -%}
        {{ options.append("-no_dad") }}
      {%- elif dad['enabled'] is sameas false -%}
        {{ options.append("no_dad") }}
      {%- endif -%}

      {#- Neighbour Unreachability Detection -#}
      {%-   if nud['enabled'] is sameas true -%}
        {{ options.append("nud") }}
      {%- elif nud['enabled'] is sameas false -%}
        {{ options.append("-nud") }}
      {%- endif -%}

      {#- Router advertisement options
       #  Note that forced router advertisement is enabled with a
       #  dedicated 'ipv6_cpe_wanif' rc variable. We only process
       #  non-forced rtadv options here. -#}
      {%-   if rtadv['enabled'] is sameas true
          and  rtadv['forced'] is not sameas true
          and  slaac['enabled'] is not sameas false
      -%}
        {{ options.append("accept_rtadv") }}
      {%- elif rtadv['enabled'] is sameas false
            or slaac['enabled'] is sameas false
      -%}
        {{ options.append("-accept_rtadv") }}
      {%- endif -%}

      {#- Link local autoconfiguration -#}
      {%-   if ll['enabled'] is sameas true -%}
        {{ options.append("auto_linklocal") }}
      {%- elif ll['enabled'] is sameas false -%}
        {{ options.append("-auto_linklocal") }}
      {%- endif -%}

      {#----------------------------------------------------------------
       # Static addresses
       #--------------------------------------------------------------#}
      {#- Main static IPv6 address -#}
      {%- if static | length > 0 -%}
        {#- Get and normalize main IPv6 address for the interface -#}
        {%- set main_address_def = static[0] -%}
        {#- Format the main IPv6 address -#}
        {%- set main_address =
          helpers.format_inet6_address(main_address_def) -%}
        {#- Store the main address -#}
        {%- if main_address -%}
          {{ options.append(main_address) }}
        {%- endif -%}
      {%- endif -%}

    {%- endif -%}
  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}

{#======================================================================
 # Get interface options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the
 # interface itself.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro get_interface_options(interface, indexes) -%}
  {%- set options = [] -%}

  {#- Interface activation options -#}
  {%-   if interface['enabled'] is sameas true -%}
    {#- 'up' is only required when no static address is defined
     #   and DHCP is disabled -#}
    {%- if  interface['inet4']['static'] | length == 0
        and interface['inet4']['dhcp']['enabled'] is not sameas true -%}
      {{ options.append("up") }}
    {%- endif -%}
  {%- elif interface['enabled'] is sameas false -%}
    {{ options.append("down") }}
  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}

{#======================================================================
 # Get link options
 #----------------------------------------------------------------------
 # This macro builds a list of ifconfig options related to the link
 # layer, then echoes this list as a JSON string.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro get_link_options(interface, indexes) -%}
  {%- set options = [] -%}

  {#- We only process link options for enabled interfaces -#}
  {%- if interface['enabled'] is sameas true -%}

    {#- Ethernet MTU -#}
    {%- if interface['ethernet']['mtu'] | int > 0 -%}
      {{ options.append("mtu " ~ interface['ethernet']['mtu']) }}
    {%- endif -%}

    {#- Ethernet address -#}
    {%- if interface['ethernet']['randomized'] is sameas true -%}
      {{ options.append("address random") }}
    {%- elif interface['ethernet']['address'] is not sameas None -%}
      {{ options.append("address " ~ interface['ethernet']['address']) }}
    {%- endif -%}

  {%- endif -%}

  {{ options | to_json }}
{%- endmacro -%}
